## 0.9.1

-   Bug fix

## 0.9.0

-   PlanningCenterApiResponse now includes `data` as `List<PlanningCenterApiData>` instead of a `List<Map<String, dynamic>>`.
-   `PlanningCenterApiData` objects can also be used directly in api calls.
-   File uploads are now supported with the `PlanningCenterApiFile` class.

## 0.8.3

-   Supports greater-than-or-equal and less-than-or-equal in where queries now.

## 0.8.2

-   Fixing some dart analyze warnings.

## 0.8.1

-   Replaced private class constructors (many were unused) with named `empty` constructors.

## 0.8.0

-   Added named parameters to class factory constructors to make it easier to create new objects that can be immediately posted to PlanningCenter.
-   Allow setters to take `null` to remove attributes from classes.

## 0.7.2

-   Updated the `description` in `pubspec.yaml`

## 0.7.1

-   Improved documentation for the `PlanningCenterApiQuery` class and all the classes that use it.

## 0.7.0

-   Added an `extraParams` field to the `PlanningCenterApiQuery` class so that some filters can properly be utilized. For example, `PcoServicesPlan` can be filtered with an `after` filter, but to use the `after` filter, the API must also include an `after` url parameter. These additional parameters cannot be automatically generated from the API documentation, and so it is up to the end user to include them in the `extraParams` field of the `PlanningCenterApiQuery` object.

## 0.6.2

-   Added an `error` getter to both `PcoCollection` and to `PlanningCenterApiResponse` classes to more easily access the error values.

```dart
PcoCollection items = await plan.getItems();
if (items.isError) print(items.error!.errorMessage);
```

## 0.6.1

-   Improved documentation by adding class attributes to the docstrings.

## 0.6.0

-   Added `next` and `getMore` methods on the `PcoCollection` class.
-   Removed `create` factory constructors. Now, the default constructors for each class operate
    the way those `create` constructors did, and only exist if an object can be created through the API on the server.

## 0.5.0

-   Added `create` factory constructors to classes that represent assets that can be created
    through the API. NOTE: Creating an object does not create it on the server until `save` is called.

## 0.4.1

-   Removing old references to `DataClass` and `PlanningCenterResource` classes

## 0.4.0

-   Massive refactoring of the code generation methods and therefore massive changes to the function definitions all around.
-   Much better documentation for each class and function
-   Special attributes used only for create / update functions are now supported (i.e. setting a `songId` attribute on a `PcoServicesItem` object)
-   `PcoResource` objects now have a `delete` method.

## 0.3.0

-   Most class methods return a PcoCollection<T> object now
-   PcoCollection<T> data items are coerced into lists even when the JSON:API data was just a map

## 0.2.1

-   fixed the readme

## 0.1.5

-   added 'actions' exposed by the API. Actions exist as methods on class instances. Each is documented.

## 0.1.4

-   added 'include' functionality

## 0.1.3

-   basic oauth2 implemented without any dependencies, see the readme for how to use.

## 0.1.2

-   Now handles "included" items in API results
-   Added flags to easily get all includable items
-   added static class getters to expose `canInclude`, `canOrderBy`, and `canQuery` fields
-   preliminary work under the hood for oauth2 authentication

## 0.1.1

-   Fixed readme bug

## 0.1.0

-   Initial version... supports the latest non-beta Planning Center APIs as of 2021-11-18
